-- ~ԐTvl[`B

-- sύڂ̎擾B
require('com_cached_db.lua')
local unit_info_tbl = com_cached_db.get_unit_information_table()
local ground_tbl = com_cached_db.get_ground_table()
local map_width,map_height = ks_get_mapsize()			-- }bvTCY

require('com_util.lua')

local side_info_tbl = nil

-----------------------------------------------------------------------------
-- (x,y)ɍł߂̉\n`TB͒n`ɊւȂPȋߕB
local function find_occupy_location(ground_layer, my_side, x, y, r)
	local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x,y,0,r)
	local count = table.getn(tbl_x)
	local px,py

	for i=1,count,1 do
		local gnd_tbl = ground_layer[tbl_y[i]*map_width + tbl_x[i]]
		if gnd_tbl['is_building'] and gnd_tbl['owner'] ~= my_side and
			(gnd_tbl['owner'] == -1 or side_info_tbl[my_side]['friendly'][gnd_tbl['owner']] <= 0) then
			px = tbl_x[i]
			py = tbl_y[i]
			break
		end
	end
	return px, py
end
-----------------------------------------------------------------------------
-- unit_state ڂĂ郆jbgŁA(x,y)̗אڍWō~Ԃł鏊
-- ̍WԂBindex͓ڃCfbNXB݃jbg͍lȂB
local function is_can_alight(ground_layer, x, y, unit_state, index)
	local loaded_state = ks_get_unit_status(unit_state['side'], unit_state['load'][index])
	-- אڍW𒲂ׂB
	local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x,y,1,1)
	local count = table.getn(tbl_x)
	local px,py

	for i=1,count,1 do
		local gnd_tbl = ground_layer[tbl_y[i]*map_width + tbl_x[i]]
		if ks_bit_and(ground_tbl[loaded_state['id']][gnd_tbl['id']], GROUND_CAN_ALIGHT) ~= 0 then
			px = tbl_x[i]
			py = tbl_y[i]
			break
		end
	end
	return px, py
end
-----------------------------------------------------------------------------
-- (x,y)n_ɈړꍇA~ԉ\A~ԉ\Ȓn`͂ɂ邩𒲂ׂBtrue.
local function is_can_unload(ground_layer, x, y, unit_state)
	local gnd_tbl = ground_layer[y*map_width + x]
	-- ~ԕs\ȂUB
	if ks_bit_and(ground_tbl[unit_state['id']][gnd_tbl['id']], GROUND_CAN_UNLOAD) == 0 then
		return false
	end

	local ret = false
	table.foreach(unit_state['load'],
		function(index, serial)
			if is_can_alight(ground_layer, x, y, unit_state, index) ~= nil then
				ret = true
			end
		end
	)
	return ret
end
-----------------------------------------------------------------------------
-- (cx,cy)ɍł߂n_ŁAmovable_layer ̒l̒n_TĕԂB
-- ܂A~ԉ\Ȓn`ł邱ƂƂtB
local function find_movable_unload_location(ground_layer, movable_layer, cx, cy, unit_state)
	-- PԖڂ̓ڃjbg
	local loading_unit_state = ks_get_unit_status(unit_state['side'], unit_state['load'][0])

	local dist_layer = ks_get_distance_layer(cx, cy, loading_unit_state['id'], loading_unit_state['fuel'])

	local maxp, px, py

	maxp = 0
	table.foreach(movable_layer,
		function(i, p)
			local x, y = ks_index2xy(i)
			-- ~ԉ\n`B
			if is_can_unload(ground_layer, x, y, unit_state) then
				-- ړ~ԉ\Ȉʒu̗אڍW𒲂ׂB
				local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x,y,1,1)
				local count = table.getn(tbl_x)
				for i=1,count,1 do
					-- אڍẂA퓋ڃjbgɂƂĂ̖ړInւ̋B
					local next_index = tbl_y[i]*map_width + tbl_x[i]
					if not ks_get_unit_exists(tbl_x[i], tbl_y[i]) and
						dist_layer[next_index] ~= nil and
						maxp < dist_layer[next_index] then
						maxp = dist_layer[next_index]
						px = x
						py = y
					end
				end
			end
		end
	)

	return px,py
end
-----------------------------------------------------------------------------
-- unit_state  (x,y) Ɉړ̍~ԃe[u쐬B
local function make_unload_table(ground_layer, my_side, unit_state, x, y)
	-- אڍW𒲂ׂB
	local tbl_x,tbl_y = ks_get_neighbor_xy_layer(x,y,1,1)

	local unload_tbl = {}
	-- ꏊdĎw肵Ȃ߂̃tOB
	local dec_flag = {}
	-- אڍWɑ΂ătOB
	table.foreach(tbl_x,
		function(i, v)
			dec_flag[tbl_y[i]*map_width + tbl_x[i]] = false
		end
	)

	table.foreach(unit_state['load'],
		function(index, serial)
			local count = table.getn(tbl_x)
			for i=1,count,1 do
				local tbl = {}
				local tbltmp = {}
				tbl['x'] = tbl_x[i]
				tbl['y'] = tbl_y[i]
				tbltmp[0] = tbl
				-- tOĂȂɑ΂č~ԑ𒲍A\Ȃ΂̈ʒuw肷B
				if dec_flag[tbl_y[i]*map_width + tbl_x[i]] == false then
					successlist = ks_set_unload(my_side, unit_state['serial'], x, y, tbltmp, false)
					if successlist[tbl_y[i]*map_width + tbl_x[i]] then
						-- We[u̒ǉB
						unload_tbl[index] = tbl
						-- tO𗧂ĂB
						dec_flag[tbl_y[i]*map_width + tbl_x[i]] = true
						break
					end
				end
			end
		end
	)
	return unload_tbl
end
-----------------------------------------------------------------------------
-- JC^[tF[X
com_default_unload = {}

com_default_unload['init_on_phasestart'] = function()
	side_info_tbl = ks_get_side()
end
-----------------------------------------------------------------------------
-- ~ԁ^~Ԓn_ڎwB߂l͈ړWC~ԐWe[uB
com_default_unload['action_unit_unload'] = function(ground_layer, my_side, serial)
	local unit_state = ks_get_unit_status(my_side, serial)
	local unit_info = unit_info_tbl[unit_state['id']]

--	print_log("UNLOAD MINING...")
	-- Ƃ肠R̒l𔼌aƂāA͂̐̉\n`TB
	local cx,cy = find_occupy_location(ground_layer, my_side, unit_state['x'], unit_state['y'], unit_state['fuel'])
	if cx == nil then
		return
	end
--	print_log("UNLOAD PURPOSE",cx,cy)
	-- ړłȂȂ̂ŁȀꍇ͈ړ~ԉ\Ȓߒn`TB
	-- Ȓ̈ړ\͈͂𒲂ׂB
	local movable_layer = ks_get_distance_layer(unit_state['x'], unit_state['y'], unit_state['id'], unit_state['fuel'])
	local px,py = find_movable_unload_location(ground_layer, movable_layer, cx, cy, unit_state)
	if px == nil then
		return
	end
--	print_log("UNLOAD STATE", serial, unit_state['x'], unit_state['y'])
--	print_log("UNLOAD TO",px,py)

	-- Ȓ̈ړ\͈͂𒲂ׂB
	local movex, movey = com_util.get_way_xy(px, py, my_side, serial, unit_state['fuel'])
--	print_log("MOVE TO",movex,movey)

	-- ڕWn_ɓBłꍇA~ԃe[u쐬B
	if movex == px and movey == py then
		local unload_tbl = make_unload_table(ground_layer, my_side, unit_state, movex, movey)
		return movex,movey,unload_tbl
	else
		return movex,movey
	end
end
-----------------------------------------------------------------------------
